import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provincePolicyGetWeightRange = createAsyncThunk(
  "PROVINCE_POLICY_GET_WEIGHT_RANGE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    const { data, status } = await axios.get("management_hatching_age_range/", {
      params: d,
    });
    dispatch(LOADING_END());
    return { data, status };
  }
);

export const provincePolicySubmitWeightRange = createAsyncThunk(
  "PROVINCE_POLICY_SUBMIT_WEIGHT_RANGE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.post(
        "management_hatching_age_range/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provincePolicyEditWeightRange = createAsyncThunk(
  "PROVINCE_POLICY_EDIT_WEIGHT_RANGE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.put(
        `management_hatching_age_range/${d.id}/`,
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provincePolicyDeleteWeightRange = createAsyncThunk(
  "PROVINCE_DELETE_WEIGHT_RANGE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        `management_hatching_age_range/${d}/`
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
